﻿using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule.MonthViewSingle;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PrintMonthlySchedule
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }       
        private void Form1_Load(object sender, EventArgs e)
        {
            CreationUIElement creationFilter = new CreationUIElement(64);
            this.ultraMonthViewSingle1.CreationFilter = creationFilter;
            // Create an appointment
            this.CreateAppointment();

            // Set the UltraDayView's CalendarInfo to 
            // the UltraCalendarInfo control.
            // This are what give the UltraDayView its appointments.
            this.ultraMonthViewSingle1.CalendarInfo = this.ultraCalendarInfo1;

            // Set the UltraSchedulePrintDocument's CalendarInfo and 
            // to UltraCalendarInfo control.
            // This allows the document to use the same appointments that
            // your UltraDayView use.
            this.ultraSchedulePrintDocument1.CalendarInfo = this.ultraCalendarInfo1;

            // Set the UltraPrintPreviewDialog's Document property to 
            // the UltraSchedulePrintDocument
            this.ultraPrintPreviewDialog1.Document = this.ultraSchedulePrintDocument1;
        }
        private void CreateAppointment()
        {
            // Make up an appointment to show on the calendar
            DateTime myStartTime = new DateTime(2013, 10, 8, 8, 23, 3);
            DateTime myEndTime = new DateTime(2013, 10, 8, 12, 23, 20);
            this.ultraCalendarInfo1.Appointments.Add(myStartTime, myEndTime, ("NI - 302 - Walla Walla Company"));
        }
        private void ultraButton1_Click(object sender, EventArgs e)
        {
            this.ultraPrintPreviewDialog1.ShowDialog(this);
        }
    }
    public class CreationUIElement : IUIElementCreationFilter
    {
        private int height;
        private int currentHeight;
        public CreationUIElement(int Height)
        {
            height = Height;
        }

        public void AfterCreateChildElements(UIElement parent)
        {
            DayUIElement El = parent as DayUIElement;
            if (El != null && El.ChildElements.Count > 0)
            {
                currentHeight = 25;
                foreach (SingleDayAppointmentUIElement item in El.ChildElements.OfType<SingleDayAppointmentUIElement>())
                {
                    item.Rect = new Rectangle(item.Rect.X, El.Rect.Y + currentHeight, item.Rect.Width, height);
                    currentHeight = currentHeight + height + 1;
                }
            }
            EditorWithTextUIElement ET = parent as EditorWithTextUIElement;
            if (ET != null && ET.ChildElements.Count > 0)
            {
                EditorWithTextDisplayTextUIElement editorwithText = ET.GetDescendant(typeof(EditorWithTextDisplayTextUIElement)) as EditorWithTextDisplayTextUIElement;
                editorwithText.Rect = new Rectangle(parent.Rect.X, parent.Rect.Y, 50, 65);
                editorwithText.MultiLine = true;
                editorwithText.WrapText = true;
            }          
        }
        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}
